"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var SSHConfig = require("ssh-config");
var fs = require("fs");
var os = require("os");
var path = require("path");
var chalk = require("chalk-pipe");
var enquirer_1 = require("enquirer");
var Questions_1 = require("./Questions");
var HostOperations_1 = require("./Enums/HostOperations");
var MainMenu_1 = require("./Enums/MainMenu");
var SSHX = (function () {
    function SSHX() {
        this.settingsPath = path.join(os.homedir(), '.sshx_settings.json');
        if (fs.existsSync(this.settingsPath)) {
            try {
                this.settings = JSON.parse(fs.readFileSync(this.settingsPath, 'utf8'));
            }
            catch (err) {
            }
        }
        else {
            this.settings = {
                configPath: path.join(os.homedir(), '.ssh/config'),
            };
            fs.writeFileSync(this.settingsPath, JSON.stringify(this.settings));
        }
    }
    SSHX.prototype.main = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(chalk('green')("SSHX Version " + this.getVersion()));
                        return [4, this.showMainMenu()];
                    case 1:
                        _a.sent();
                        console.log(chalk('green')("Successfully updated."));
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.showMainMenu = function () {
        return __awaiter(this, void 0, void 0, function () {
            var mainMenuAnswer, _a, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, enquirer_1.prompt(Questions_1.default.MainMenuQuestion)];
                    case 1:
                        mainMenuAnswer = _b.sent();
                        _a = mainMenuAnswer.selectedMenu;
                        switch (_a) {
                            case MainMenu_1.default.DeleteHost: return [3, 2];
                            case MainMenu_1.default.CloneHost: return [3, 2];
                            case MainMenu_1.default.EditHost: return [3, 2];
                            case MainMenu_1.default.AddNewParametersToHost: return [3, 2];
                            case MainMenu_1.default.AddNewHost: return [3, 4];
                            case MainMenu_1.default.Settings: return [3, 8];
                        }
                        return [3, 10];
                    case 2: return [4, this.askHostOperations(mainMenuAnswer.selectedMenu)];
                    case 3:
                        _b.sent();
                        return [3, 10];
                    case 4:
                        _b.trys.push([4, 6, , 7]);
                        return [4, this.newHost()];
                    case 5:
                        _b.sent();
                        return [3, 7];
                    case 6:
                        err_1 = _b.sent();
                        console.log(err_1, 'addnewhost');
                        return [3, 7];
                    case 7: return [3, 10];
                    case 8: return [4, this.editSettings()];
                    case 9:
                        _b.sent();
                        return [3, 10];
                    case 10: return [2];
                }
            });
        });
    };
    SSHX.prototype.editSettings = function () {
        return __awaiter(this, void 0, void 0, function () {
            var formPrompt;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Questions_1.default.SettingsForm.choices[0].initial = this.settings.configPath;
                        return [4, enquirer_1.prompt(Questions_1.default.SettingsForm)];
                    case 1:
                        formPrompt = _a.sent();
                        fs.writeFileSync(this.settingsPath, JSON.stringify(formPrompt.settings));
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.addNewParametersToHost = function (index) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, answer, formPrompt;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, enquirer_1.prompt(Questions_1.default.HostParams)];
                    case 1:
                        answer = _b.sent();
                        return [4, enquirer_1.prompt({
                                name: 'newParams',
                                type: 'form',
                                message: 'Fill form fields.',
                                choices: answer.selectedParams
                                    .map(function (item) { return ({
                                    name: item,
                                    message: item,
                                }); }),
                            })];
                    case 2:
                        formPrompt = _b.sent();
                        (_a = this.parsedSSHConfigFile[index].config).push.apply(_a, Object.keys(formPrompt.newParams)
                            .map(function (param) { return ({
                            type: 1,
                            param: param,
                            separator: ' ',
                            value: formPrompt.newParams[param],
                            before: '\t',
                            after: '\n'
                        }); }));
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.newHost = function () {
        return __awaiter(this, void 0, void 0, function () {
            var answer, formPrompt, newHost;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, enquirer_1.prompt(Questions_1.default.HostParams)];
                    case 1:
                        answer = _a.sent();
                        return [4, enquirer_1.prompt({
                                name: 'newHost',
                                type: 'form',
                                message: 'Add Host',
                                choices: ['Host'].concat(answer.selectedParams).map(function (item) { return ({
                                    name: item,
                                    message: item,
                                }); }),
                            })];
                    case 2:
                        formPrompt = _a.sent();
                        this.parseHostFile();
                        newHost = formPrompt.newHost;
                        this.parsedSSHConfigFile.push({
                            type: 1,
                            param: 'Host',
                            separator: ' ',
                            value: newHost.Host,
                            before: '\n',
                            after: '\n',
                            config: Object.keys(newHost).slice(1)
                                .map(function (param) { return ({
                                type: 1,
                                param: param,
                                separator: ' ',
                                value: newHost[param],
                                before: '\t',
                                after: '\n'
                            }); }),
                        });
                        this.writeConfigFile();
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.writeConfigFile = function () {
        var configContent = SSHConfig.stringify(this.parsedSSHConfigFile);
        fs.writeFileSync(this.settings.configPath, configContent);
    };
    SSHX.prototype.parseHostFile = function () {
        if (fs.existsSync(this.settings.configPath)) {
            var configContent = fs.readFileSync(this.settings.configPath, 'utf8');
            this.parsedSSHConfigFile = SSHConfig.parse(configContent);
        }
        else {
            console.log(chalk('red')("SSH Config file does not exists: " + this.settings.configPath));
            process.exit(1);
        }
    };
    SSHX.prototype.hostList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var questionHostList, answer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.parseHostFile();
                        questionHostList = __assign({}, Questions_1.default.HostList);
                        questionHostList.choices = this.parsedSSHConfigFile
                            .filter(function (item) { return item.param.trim() === 'Host'; })
                            .map(function (item) { return ({
                            message: item.value,
                            value: item.value,
                        }); });
                        return [4, enquirer_1.prompt(questionHostList)];
                    case 1:
                        answer = _a.sent();
                        this.selectedHost = answer.selectedHost;
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.askHostOperations = function (operation) {
        return __awaiter(this, void 0, void 0, function () {
            var index;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.hostList()];
                    case 1:
                        _a.sent();
                        index = this.parsedSSHConfigFile.findIndex(function (item) { return item.value === _this.selectedHost; });
                        return [4, this.hostOperation(operation, index)];
                    case 2:
                        _a.sent();
                        this.writeConfigFile();
                        return [2];
                }
            });
        });
    };
    SSHX.prototype.hostOperation = function (operation, index) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, formPrompt, params_1, length;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = operation;
                        switch (_a) {
                            case HostOperations_1.default.DeleteHost: return [3, 1];
                            case HostOperations_1.default.AddNewParametersToHost: return [3, 2];
                            case HostOperations_1.default.EditHost: return [3, 4];
                            case HostOperations_1.default.CloneHost: return [3, 6];
                        }
                        return [3, 8];
                    case 1:
                        {
                            this.parsedSSHConfigFile.splice(index, 1);
                        }
                        return [3, 8];
                    case 2: return [4, this.addNewParametersToHost(index)];
                    case 3:
                        _b.sent();
                        return [3, 8];
                    case 4: return [4, enquirer_1.prompt({
                            name: 'params',
                            type: 'form',
                            message: 'Edit host',
                            choices: [{
                                    param: 'Host',
                                    value: this.parsedSSHConfigFile[index].value,
                                }].concat(this.parsedSSHConfigFile[index].config).map(function (item) { return ({
                                name: item.param,
                                message: item.param,
                                initial: item.value,
                            }); }),
                        })];
                    case 5:
                        formPrompt = _b.sent();
                        params_1 = formPrompt.params;
                        this.parsedSSHConfigFile[index] = {
                            type: 1,
                            param: 'Host',
                            separator: ' ',
                            value: params_1.Host,
                            before: '\n',
                            after: '\n',
                            config: Object.keys(params_1).slice(1)
                                .map(function (param) { return ({
                                type: 1,
                                param: param,
                                separator: ' ',
                                value: params_1[param],
                                before: '\t',
                                after: '\n'
                            }); }),
                        };
                        return [3, 8];
                    case 6:
                        length = this.parsedSSHConfigFile.push(__assign({}, this.parsedSSHConfigFile[index]));
                        return [4, this.hostOperation(HostOperations_1.default.EditHost, length - 1)];
                    case 7:
                        _b.sent();
                        _b.label = 8;
                    case 8: return [2];
                }
            });
        });
    };
    SSHX.prototype.getVersion = function () {
        return require('../package.json').version;
    };
    return SSHX;
}());
exports.default = SSHX;
new SSHX().main();
//# sourceMappingURL=index.js.map